/* fibonacci ricorsiva con visualizzazione sequenza di invocazioni ricorsive:
equivalentemente: visualizzazione della pila dei record di attivazione attivi 
durante il calcolo di ogni valore di fibor() */
#include <stdio.h>

#define LIMIT 10

/* segue una rudimentale implementazione di stack di int senza alcun controllo
sui limiti dello stack (cfr. con stk.c)*/

static int stack[LIMIT+1];
static int pos = 0;

void push(int i)
{
	stack[pos++] = i;	
}

int pop(void)
{
	return stack[--pos];
}

void show(void)
{
	int j;

	for(j = 0; j < pos; j++)
		printf("[%d]",stack[j]);
	printf("[<--\n");
}

/* versione ricorsiva */
long fibor(int i)
{
	long k;

	push(i);
	show();
	k = i <= 1 ? i : fibor(i-1) + fibor(i-2); 
	pop();
	return k;
}

int main(void)
{
	int i;

	printf("Tabella numeri di Fibonacci, calcolati ricorsivamente\n\n");
	for(i = 0; i <= LIMIT; i++)
		printf("fibo(%d) = %ld\n",i,fibor(i));
}
